#!/usr/local/bin/perl

require "./setup.cgi";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
if ($ENV{'QUERY_STRING'} ne '') { $buffer .= "\&$ENV{'QUERY_STRING'}"; }

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {

	($name,$value) = split(/=/,$pair);

	if ($name eq '') { next; }
	if ($name ne 'FF' && $name ne 'IDX' && $name ne 'action') { push(@Buf,"$name=$value"); }

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	&jcode'convert(*value,'euc');

	$value =~ s/<//g;
	$value =~ s/>//g;
	$value =~ s/\n//g;
	$value =~ s/\r//g;
	$value =~ s/\f//g;
	$value =~ s/\t//g;

	$FORM{$name} = $value;
}

if ($FORM{'strings'} ne '') {

	$strings_sjis = $FORM{'strings'};
	&jcode'convert(*strings_sjis,'sjis');
}

($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg) = gmtime(time - 24*60*60);
$tmp_remove = sprintf("%04d%02d%02d%02d%02d%02d",$yearg +1900,$mong +1,$mdayg,$hourg,$ming,$secg);

$check = (eval { opendir(DIR,$base_dir); }, $@ eq "");
if (!$check) { &error("G[(005)","Can't get directory"); }

@BASE = @NOW = @END = ();
@list = readdir(DIR);

foreach $directory (@list) {

	next if $directory eq '.';
	next if $directory eq '..';
	unless (-d "$base_dir$directory") { next; }

	if ($directory =~ /(\d+)\.1/) { push(@NOW,$directory); }
	elsif ($directory =~ /(\d+)\.0/) { push(@END,$directory); }
	elsif ($directory < $tmp_remove) {

		&delete_all("$base_dir$directory");
		rmdir("$base_dir$directory")
	}
}

close(DIR);

if ($FORM{'action'} eq 'endlist') { @BASE = @END; @BASE = sort { $b <=> $a; } @BASE; }
else { @BASE = @NOW; @BASE = sort { $a <=> $b; } @BASE; }

if ($FORM{'FF'} eq '') { $FF = 0; } else { $FF = $FORM{'FF'}; }
$TO = $FF + $page - 1;
if ($TO > $#BASE) { $TO = $#BASE; }
$hit = 0;
$next_num = '';

foreach $num ($FF .. $#BASE) {

	$directory = $BASE[$num];

	if ($FORM{'action'} eq 'photo') { # ʐ^̂

		&GetData($directory);
		if (!$GOODS{$directory}{'attc'}) { next; }
	}

	if ($FORM{'strings'} ne '') {

		&GetData($directory);
		$search_strings = "$GOODS{$directory}{'email'} $GOODS{$directory}{'handle'} $GOODS{$directory}{'goods_remarks'} $GOODS{$directory}{'goods_name'} $directory";
		&jcode'convert(*search_strings,'euc');

		if ($search_strings =~ /^([\x00-\x7F]|[\x8E\xA1-\xFE][\xA1-\xFE]|\x8F[\xA1-\xFE]{2})*$FORM{'strings'}/i) { ; } else { next; }
	}

	if ($FORM{'FF'} ne '') {

		$allhits = $FORM{'allhits'};
		if ($hit == $page) { last; }
		else { push(@NEW,$directory); $hit++; }
	}
	else {
		if ($allhits % $page == 0) { push(@Index,$num); }
		if ($hit < $page) { $hit++; push(@NEW,$directory); }
		$allhits++;

		if (defined($code{$code})) { push(@ERR,$code); }
		else { $code{$code} = $code; }
	}
}

if ($FORM{'allhits'} eq '') { push(@Buf,"allhits=$allhits"); $FORM{'allhits'} = $allhits; }
if ($FORM{'FF'} ne '') { @Index = split(/\s/,$FORM{'IDX'}); }

$count_new = @NEW;

print "Content-type: text/html\n\n";

print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
</HEAD>
$body
<div align=right>̏ $date_now ݂̂̂ł</div><p>
$head_message
<table><tr><td>$msg_top1</td></tr></table><p>
EOF

if ($FORM{'action'} ne 'endlist') {

	print <<"EOF";
<form method=POST action="auction.cgi">
<table border=0 cellpadding=5><tr><td bgcolor=#cd5c5c><font color=#ffffff>/oiԍ</font> <input type=text name="strings" value="$strings_sjis" size=20>
<input type=submit value=""><input type=reset value=""></td></tr></table>
</form>
<p>
EOF

}

if (!@NEW) { print "܂.<p>\n"; }
else {

	if ($FORM{'action'} eq 'endlist') { $tfee = "ŏIi"; $tmes = "D"; } else { $tfee = "݂̉i"; $tmes = "c莞"; }

	if ($FORM{'action'} eq 'photo') { #-- ʐ^̂

	if ($FORM{'action'} ne 'endlist') { print "<div align=left>&nbsp;&nbsp;&nbsp;<img src=\"$image_dir/photo.gif\" alt=\"ʐ^\" width=17 height=12> [̂|<a href=\"auction.cgi\"><b>ׂ</b></a>]</div>"; }

		print <<"EOF";
<table cellpadding=10 sellspacing=10>
EOF
		$f = 0;
		foreach $directory (@NEW) {

			$link = "";
			$now_fee = 0;

			undef %{$GOODS{$directory}};
			&GetData($directory);

			1 while $GOODS{$directory}{'min_fee'} =~ s/(.*\d)(\d\d\d)/$1,$2/g;

			$c++;
			unless ($c % 2) { $bg = "#ffeedd"; } else { $bg = "#ffffff"; }

			if ($GOODS{$directory}{'attc'} ne '') { $goods_view = "<img src=\"$image_dir/photo.gif\" alt=\"摜\" width=17 height=12>"; } #ʐ^t
			else { $goods_view = "&nbsp;"; }

			@TEND = ();
			if (open(DATA,"$base_dir$directory\/tender.$data_ext")) {

				@TEND = <DATA>;
				close(DATA);

				$LAST_TEND = $TEND[$#TEND];

				($number2,$tend,$handle,$email,$tel,$fax,$date,$host) = &DecodeCSV($LAST_TEND);
				$now_fee = $tend;
				$now_fee2 = 0;
			}
			else { $now_fee2 = 1; }

			($limit,$remain) = &remain($directory);
			if ($remain <= 0 && $ext == 1) {

				if (rename("$base_dir$directory","$base_dir$fnum\.0")) {

					if (-e "$base_dir$fnum\.0\/stop.$data_ext") { next; }
					if (!open(END,"> $base_dir$fnum\.0\/stop.$data_ext")) { &error2("VXeG[(006)","$fnum̓DIɎs܂."); }
					if (@TEND) { print END $LAST_TEND; $type = 1; }
					else { $type = 0; }
					close(END);
					$ext = 0;
					$FORM{'allhits'} --;

					&end_info($fnum,$GOODS{$directory}{'handle'},$GOODS{$directory}{'email'},$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'passwd'},$type);

					if (@TEND) {

						($number2_c,$tend_c,$handle_c,$email_c,$tel_c,$fax_c,$date_c,$host_c) = &DecodeCSV($LAST_TEND);
						&end_info2($fnum,$number2_c,$handle_c,$email_c,$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'remarks'});
					}

					next;
				}
				else { &error2("VXeG[(007)","$fnum̓DIɎs܂."); }
			}

			$err = 0;

			if ($ext == 0) { next; }

			$min_fee = $GOODS{$directory}{'min_fee'};
			1 while $min_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

			if ($GOODS{$directory}{'max_fee'} != 0) {

				$max_fee = $GOODS{$directory}{'max_fee'};
				1 while $max_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;
				$max_fee .= " ~";
			}
			else { $max_fee = "-"; }

			if ($now_fee == 0) { $now_fee = $min_fee; }
			1 while $now_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

			$tend_count = @TEND;
			if ($tend_count == 0) { $tend = "$now_fee ~"; }
			else { $tend = "$now_fee ~/$tend_count D"; }

			foreach $IMG (split("\0",$GOODS{$directory}{'attc'})) {

				unless ($i % 5) { print "<TR>\n"; $tron = 1; }

				$GOODS{$directory}{'goods_name'} =~ s/\"//g;

				print <<"EOF";
<Td><table cellpadding=0 sellspacing=0>
<tr><td><a href="tender.cgi?number=$fnum$ext"><img src="image.cgi?dir=$directory&iname=$IMG" alt="$GOODS{$directory}{'goods_name'}" border=0 width=100></a></td></tr>
<tr><td align=center><a href="tender.cgi?number=$fnum$ext">$tend</a></td></tr>
</table></Td>
EOF
				if ($i % 5 == 4) { print "</TR>\n"; $tron = 0; }
				$i++;

				last;
			}
		}

		if ($tron) { print "</TR>\n"; }
		print "</table>\n";

	}
	else { #-- ׂĕ\

		if ($FORM{'action'} ne 'endlist') { print "<div align=left>&nbsp;&nbsp;&nbsp;<img src=\"$image_dir/photo.gif\" alt=\"ʐ^\" width=17 height=12> [<a href=\"auction.cgi?action=photo\"><b>̂</b></a>|ׂ]</div>"; }

		print <<"EOF";
<table border=$border cellpadding=1 cellspacing=2 width=100%>
<tr>
<td bgcolor=#555555 align=center><font color=#ffffff size=+1>ʐ^</font></td>
<td bgcolor=#555555 align=center><font color=#ffffff size=+1>i</font></td>
<td bgcolor=#555555 align=center><font color=#ffffff size=+1>]Di</font></td>
<td bgcolor=#555555 align=center><font color=#ffffff size=+1>$tfee</font></tdh>
<td bgcolor=#555555 align=center><font color=#ffffff size=+1>D</font></td>
<td bgcolor=#555555 align=center><font color=#ffffff size=+1>$tmes</font></td>
</tr>
EOF
		$f = 0;
		foreach $directory (@NEW) {

			$link = "";
			$now_fee = 0;

			undef %{$GOODS{$directory}};
			&GetData($directory);

			1 while $GOODS{$directory}{'min_fee'} =~ s/(.*\d)(\d\d\d)/$1,$2/g;

			$c++;
			unless ($c % 2) { $bg = "#ffeedd"; } else { $bg = "#ffffff"; }

			if ($GOODS{$directory}{'attc'} ne '') { $goods_view = "<img src=\"$image_dir/photo.gif\" alt=\"摜\" width=17 height=12>"; } #ʐ^t
			else { $goods_view = "&nbsp;"; }

			@TEND = ();
			if (open(DATA,"$base_dir$directory\/tender.$data_ext")) {

				@TEND = <DATA>;
				close(DATA);

				$LAST_TEND = $TEND[$#TEND];

				($number2,$tend,$handle,$email,$tel,$fax,$date,$host) = &DecodeCSV($LAST_TEND);
				$now_fee = $tend;
				$now_fee2 = 0;
			}
			else { $now_fee2 = 1; }

			($limit,$remain) = &remain($directory);
			if ($remain <= 0 && $ext == 1) {

				if (rename("$base_dir$directory","$base_dir$fnum\.0")) {

					if (-e "$base_dir$fnum\.0\/stop.$data_ext") { next; }
					if (!open(END,"> $base_dir$fnum\.0\/stop.$data_ext")) { &error2("VXeG[(006)","$fnum̓DIɎs܂."); }
					if (@TEND) { print END $LAST_TEND; $type = 1; }
					else { $type = 0; }
					close(END);
					$ext = 0;
					$FORM{'allhits'} --;

					&end_info($fnum,$GOODS{$directory}{'handle'},$GOODS{$directory}{'email'},$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'passwd'},$type);

					if (@TEND) {

						($number2_c,$tend_c,$handle_c,$email_c,$tel_c,$fax_c,$date_c,$host_c) = &DecodeCSV($LAST_TEND);
						&end_info2($fnum,$number2_c,$handle_c,$email_c,$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'remarks'});
					}

					next;
				}
				else { &error2("VXeG[(007)","$fnum̓DIɎs܂."); }
			}

			$err = 0;

			if ($ext == 1) {

				if ($remain <= 0) { $limit_time = "<td bgcolor=$bg align=right><font color=#ff0000>ERROR(008)</font></td>"; $err = 1; }
				else {
					if ($remain < 3600) { $color ="#ff0000"; }
					elsif ($remain >= 3600 && $remain < 86400) { $color ="#ff3333"; }
					elsif ($remain >= 86400 && $remain < 172800) { $color ="#ff5555"; }
					else { $color ="#000000"; }

					$limit_time = "<td bgcolor=$bg align=right><font color=$color>$limit</font></td>";
				}
			}
			else {
				if ($now_fee2) { $limit_time = "<td bgcolor=$bg align=center>DȂ</td>"; }
				else { $limit_time = "<td bgcolor=$bg align=center>D҈ē</td>"; }
			}

			$min_fee = $GOODS{$directory}{'min_fee'};
			1 while $min_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

			if ($GOODS{$directory}{'max_fee'} != 0) {

				$max_fee = $GOODS{$directory}{'max_fee'};
				1 while $max_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;
				$max_fee .= " ~";
			}
			else { $max_fee = "-"; }

			if ($now_fee == 0) { $now_fee = $min_fee; }
			1 while $now_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

			$tend_count = @TEND;
			if ($tend_count == 0) { $tend_count = "-"; }

			if ($link eq "") {

				if ($err) { $link = "$GOODS{$directory}{'goods_name'}"; }
				else { $link = "<a href=\"tender.cgi?number=$fnum$ext\">$GOODS{$directory}{'goods_name'}</a>"; }
			}

			print <<"EOF";
<tr>
<td bgcolor=$bg align=center>$goods_view</td>
<td bgcolor=$bg align=left>$link</td>
<td bgcolor=$bg align=right>$max_fee</td>
<td bgcolor=$bg align=right><b>$now_fee ~</b></td>
<td bgcolor=$bg align=right>$tend_count</td>
$limit_time
EOF
			print "</tr>\n";
		}

		print <<"EOF";
</table><p>
EOF
	}

	if ($FORM{'action'} eq 'endlist') { ; }
	elsif ($FORM{'action'} eq 'photo') { print "<div align=right>[<a href=\"auction.cgi\"><b>ׂĂ\\</b></a>]</div>\n"; }
	else { print "<div align=right>[<a href=\"auction.cgi?action=photo\"><b>ʐ^̂ݕ\\</b></a>]</div>\n"; }

	print " $FORM{'allhits'}  [ ";

	$buf = join('&',@Buf);
	$idx = join('+',@Index);

	foreach (0 .. $#Index) {

		$view_page = $_ + 1;
		if ($FF == $Index[$_] || ($FORM{'FF'} eq '' && $_ == 0)) { print " <b>$view_page</b>"; $page_now = $view_page; }
		else { print " <a href=\"auction.cgi?action=$FORM{'action'}&$buf&IDX=$idx&FF=$Index[$_]\">$view_page</a>"; }
	}

	$FROM = $page_now * $page - ($page - 1);
	$LAST = $FROM + $count_new - 1;

	print " ] [<A HREF=\"auction.cgi\">ŐV̏</A>]<hr size=2 noshade><div align=right>y[W <b>$page_now</b> ($FROM`$LAST)</div><p>\n";
}

print <<"EOF";
<h3>
[<a href="regist.cgi">oi</a>]
[<A HREF="$end" target="_top">$end_name</A>]
EOF

if ($FORM{'action'} ne 'endlist') { print "[<A HREF=\"auction.cgi?action=endlist\">DIꗗ</A>]\n"; }
else { print "[<A HREF=\"auction.cgi\">oiꗗ</A>]\n"; }

print <<"EOF";
[<A HREF="redirect.cgi">oiҌʈē</A>]
</h3>
<table><tr><td>$msg_btm1</td></tr></table><p>
</body></html>
EOF

exit;
