#!/usr/local/bin/perl

require "./setup.cgi";

&ReadParse;

while (($key,$val) = each %in) {

	if ($key eq '') { next; }
	if ($key eq 'goods_view') { next; }

	&jcode'h2z_sjis(*val); # pJiSp(SJIS)ϊ
	&jcode'convert(*val,'sjis'); # SJISϊ

	$val =~ s/\t//g;
	$val =~ s/\r\n/\r/g;
	$val =~ s/\n/\r/g;

	$val =~ s/</&lt;/g;
	$val =~ s/>/&gt;/g;
	$val =~ s/"/&quot;/g;

	if ($key eq ";attc;") { $attc = 1; }
	elsif ($key eq ";remove;") { $remove = 1; }
	elsif ($key eq ";no_attc;") { $no_attc = 1; }
	elsif ($key eq ";check;") { $view_check = 1; }
	else { $in{$key} = $val; }
}

$cname = $ENV{'SCRIPT_NAME'};
$cookies = $ENV{'HTTP_COOKIE'};

@pairs = split(/;/,$cookies);
foreach $pair (@pairs) {

	($key,$val) = split(/=/,$pair,2);
	$key =~ s/ //g;

	if ($key eq $cname) {

		@pairs = split(/,/,$val);
		foreach $pair (@pairs) {

			($key,$val) = split(/:/,$pair,2);
			$COOKIE{$key} = $val;
		}
		last;
	}
}

if ($in{'handle'} ne "") { $COOKIE{'handle'} = $in{'handle'}; }
if ($in{'email'} ne "") { $COOKIE{'email'} = $in{'email'}; }
if ($in{'tel'} ne "") { $COOKIE{'tel'} = $in{'tel'}; }
if ($in{'fax'} ne "") { $COOKIE{'fax'} = $in{'fax'}; }

# |
($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg) = gmtime(time - 24*60*60);
$tmp_remove = sprintf("%04d%02d%02d%02d%02d%02d",$yearg +1900,$mong +1,$mdayg,$hourg,$ming,$secg);
$tmp_remove2 = time - 86400;

$check = (eval { opendir(DIR,$tmp_dir); }, $@ eq "");
if (!$check) { &error("G[","Can't get directory"); }

@BASE = ();
@list = readdir(DIR);

foreach $directory (@list) {

	next if $directory eq '.';
	next if $directory eq '..';

	if ($directory =~ /^(\d+)\.(.+)$/) {

		$tfile = $1;
		$ext = $2;
		if ($tfile < $tmp_remove) { unlink("$tmp_dir$tfile\.$ext"); }
	}
	elsif ($directory =~ /^(\d+)$/) {

		$tfile = $1;
		if ($tfile < $tmp_remove2) { unlink("$tmp_dir$tfile"); }
	}
}

close(DIR);

$min_fee = $in{'min_fee'};
1 while $min_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

if ($in{'max_fee'} != 0) {

	$max_fee = $in{'max_fee'};
	1 while $max_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	$max_fee .= " ~";
}

$VALUE = $in{'goods_remarks'};
$VALUE =~ s/\r/<br>\r/g;
$VALUE =~ s/ /&nbsp;/g;
$VALUE =~ s/&quot;/"/g;
$VALUE =~ s/(https?|ftp|gopher|telnet|whois|news)\:([\w|\:\!\#\$\%\=\&\-\^\`\\\|\@\~\[\{\]\}\;\+\*\,\.\?\/]+)/<a href=\"$1\:$2\" target=\"_blank\">$1\:$2<\/a>/ig;

if ($view_check) { &html; exit; }
if ($remove) { &remove; &attachment; exit; }
if ($no_attc) { undef $in{'goods_view'}; }
if ($attc) { &attachment; exit; }
elsif ($in{'action'} eq 'regist') { &regist; exit; }
elsif ($in{'action'} eq 'regist2' && $no_attc) { ; }
elsif ($in{'action'} eq 'regist2') { &regist2; &attachment; exit; }

&html;

sub html {

if (!open(FILE,"$kitei")) { &error('G[',"Kt@Cǂݏo܂."); }
@KITEI = <FILE>;
close(FILE);

$date_num = sprintf("%04d%02d%02d%02d%02d%02d",$year +1900,$mon +1,$mday,$hour,$min,$sec);

if ($in{'time'} eq '') { $in{'time'} = 7; }
$c1{$in{'time'}} = " selected";
foreach (split("\0",$in{'howto_pay'})) { $c2{$_} = " checked"; }
if ($in{'howto_carriage'} eq "") { $in{'howto_carriage'} = 'D'; }
$c3{$in{'howto_carriage'}} = " checked";
if ($in{'howto_forward'} eq "") { $in{'howto_forward'} = 'x'; }
$c4{$in{'howto_forward'}} = " checked";

print "Content-type: text/html\n\n";
print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
<SCRIPT language="JavaScript">
<!--
function message()
{
	f = confirm("ɖ߂܂. 낵łH");
	return f
}
//-->
</SCRIPT>
</HEAD>
$body
<table><tr><td>$regist_message</td></tr></table>
EOF

if (@ERR) {

	unless ($no_remove) {

		&delete_all("$base_dir$in{'number'}");
		if (-e "$base_dir$in{'number'}" && !rmdir("$base_dir$in{'number'}")) { push(@ERR,"VXeG[(009)FꎞtH_폜ł܂($!)"); }
	}

	print "<hr size=2 noshade><h3>s͂sKłt</h3><ul>\n";
	foreach $i (0 .. $#ERR) { print "<li>$ERR[$i]\n"; }
	print "</ul>\n";
}

print <<"EOF";
<form method=POST action="regist.cgi">
<input type=hidden name="action" value="regist" name="form1">
EOF

if ($in{'number'} eq '') { print "<input type=hidden name=\"number\" value=\"$date_num\">\n"; }
else { print "<input type=hidden name=\"number\" value=\"$in{'number'}\">\n"; }

$limit = time + ($in{'time'} * 86400);
if ($in{'limit'} eq '') { print "<input type=hidden name=\"limit\" value=\"$limit\">\n"; }
else { print "<input type=hidden name=\"limit\" value=\"$in{'limit'}\">\n"; }

foreach (split("\0",$in{'attc'})) { print "<input type=hidden name=\"attc\" value=\"$_\">"; $i++; }
foreach $image_number (@IMAGES) { print "<input type=hidden name=\"attc\" value=\"$image_number\">"; $i++; }
if ($i) { $image_kazu = "(摜$iYtĂ܂)"; $image_del = "/폜"; }

print "<hr size=2 noshade>\n";

if ($view_check) {

	$plus_fee = &plus_fee($in{'min_fee'});
	1 while $plus_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	if ($plus_fee) { $plus_fee .= " ~"; }

	print <<"EOF";
<table width=100%>
<tr>
<td bgcolor=#ffe566 colspan=2><font size=+2><b>$in{'goods_name'}</b></font></td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>oiԍ</b></font></td>
<td bgcolor=#ffffff>$limit</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>oi</b></font></td>
<td bgcolor=#ffffff>$in{'handle'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>ŒᗎDi</b></font></td>
<td bgcolor=#ffffff>$min_fee ~</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>DP</b></font></td>
<td bgcolor=#ffffff>$plus_fee</td>
</tr>
EOF
	if ($in{'max_fee'} != 0) {

		print <<"EOF";
<tr>
<td bgcolor=#ffeedd><b>]Di</b></font></td>
<td bgcolor=#ffffff>$max_fee</td>
</tr>
EOF
	}

	print <<"EOF";
<tr>
<td bgcolor=#ffeedd><b>D</b></font></td>
<td bgcolor=#ffffff>$in{'time'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>x@</b></font></td>
<td bgcolor=#ffffff>
EOF

	foreach (split("\0",$in{'howto_pay'})) { print "$_ "; }

	print <<"EOF";
</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>S</b></font></td>
<td bgcolor=#ffffff>$in{'howto_carriage'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b></b></font></td>
<td bgcolor=#ffffff>$in{'howto_forward'}</td>
</tr>
</table>
<p>
EOF

	print "<table><tr>";
	foreach (split("\0",$in{'attc'})) { print "<td><img src=\"$tmp_url$_\" alt=\"Yt摜$i\"></td>\n"; }
	foreach $image_number (@IMAGES) { print "<td><img src=\"$tmp_url$image_number\" alt=\"Yt摜$i\"></td>\n"; }
	print "</tr></table>\n";
	if ($in{'attc'} || @IMAGES) { print "<p>\n"; }

	print "$VALUE<p>\n";

	print "<h3><u>oiҏ</u></h3>\n";
	print "<ul>\n";
	print "<li><u>d[</u> <a href=\"mailto:$in{'email'}\">$in{'email'}</a> <font size=-1> ԈႢȂǂĂɓ͂ƂmF邱Ƃ߂܂I</font>\n";
	if ($in{'tel'} ne "") { print "<li><u>dbԍ</u> $in{'tel'}\n"; }
	if ($in{'fax'} ne "") { print "<li><u>e`wԍ</u> $in{'fax'}\n"; }

	print "</ul><p>\n";
	print "<hr size=2 noshade>\n";
}

print <<'EOF';
<h3>y<u>oi鏤io^܂</u>z</h3>
EOF

print <<"EOF";
<b>jbNl[</b><br>
oi҂ł邠Ȃ̖OłBJ܂B<p>
<blockquote><input type=text name="handle" value="$COOKIE{'handle'}" size=20 maxlength=20></blockquote>
<p>

<b>i</b><br>
oiꗗɕ\\̂ł̂ŁAe悤ɊȌɏĂBSp20ȓłB<p>
<blockquote><input type=text name="goods_name" value="$in{'goods_name'}" size=40 maxlength=40></blockquote>
<p>

<b></b> <b>$image_kazu</b><br>
i̓eɂďڂĂB^O͎g܂񂪁AURLLƎN܂B<p>
<blockquote><textarea name="goods_remarks" cols=60 rows=5 wrap=off>$in{'goods_remarks'}</textarea><br>
EOF

if (!$MP) { print "<input type=submit name=\";attc;\" value=\"摜Yt$image_del\">\n"; }
else { print "( p̃uEUł͉摜Yt͂ł܂ - $HTTP_USER_AGENT )\n"; }

print <<"EOF";
</blockquote>
<p>

<b>ŒᗎDi</b><br>
DJnzłBŒJni100~łBȂ炸ݒ肵ĂB<p>
<blockquote><input type=text name="min_fee" value="$in{'min_fee'}" size=10 maxlength=10>~</blockquote>
<p>

<b>DP</b><br>
DɓDiƂĉZzłBzɂA̕\\ɂČ܂܂B<p>
<blockquote>
<table border=0>
<tr bgcolor=#888888>
<td align=center><font color=#ffffff>ŒᗎDi</font></td>
<td align=center><font color=#ffffff>DP</font></td>
</tr>
<tr bgcolor=#ffeedd>
<td align=center><font color=#000000>100 ~` 500 ~</font></td>
<td align=right><font color=#000000>50 ~</font></td>
</tr>
<tr bgcolor=#ffeedd>
<td align=center><font color=#000000>501 ~` 1,000 ~</font></td>
<td align=right><font color=#000000>100 ~</font></td>
</tr>
<tr bgcolor=#ffeedd>
<td align=center><font color=#000000>1,001 ~` 10,000 ~</font></td>
<td align=right><font color=#000000>250 ~</font></td>
</tr>
<tr bgcolor=#ffeedd>
<td align=center><font color=#000000>10,001 ~` 50,000 ~</font></td>
<td align=right><font color=#000000>500 ~</font></td>
</tr>
<tr bgcolor=#ffeedd>
<td align=center><font color=#000000>50,001 ~`</font></td>
<td align=right><font color=#000000>1,000 ~</font></td>
</tr>
</table>
</blockquote>
<p>

<b>]Di</b><br>
ݒ肷΁A̋zőD܂B
̋zz̓DĂA̋zDzƂȂ܂B
ݒ肵Ȃꍇ͉LȂłB<p>
<blockquote><input type=text name="max_fee" value="$in{'max_fee'}" size=10 maxlength=10>~</blockquote><p>
<p>

<b>D</b><br>
o^_炱̓ԂDԂƂȂ܂B
]āAo^̂܂ܓDIƂȂ܂B<p>
<blockquote><select name="time">
<option value="1"$c1{'1'}>1</option>
<option value="2"$c1{'2'}>2</option>
<option value="3"$c1{'3'}>3</option>
<option value="4"$c1{'4'}>4</option>
<option value="5"$c1{'5'}>5</option>
<option value="6"$c1{'6'}>6</option>
<option value="7"$c1{'7'}>7</option>
<option value="8"$c1{'8'}>8</option>
<option value="9"$c1{'9'}>9</option>
<option value="10"$c1{'10'}>10</option>
<option value="11"$c1{'11'}>11</option>
<option value="12"$c1{'12'}>12</option>
<option value="13"$c1{'13'}>13</option>
<option value="14"$c1{'14'}>14</option>
</select></blockquote>
<p>

<b>x@</b><br>
󂯎]@łB̓Iȕ@Ȃǂ́ADɓҊԂőkĂB<p>
<blockquote><input type=checkbox name="howto_pay" value="sU"$c2{'sU'}>sU <input type=checkbox name="howto_pay" value="X֐U"$c2{'X֐U'}>X֐U <input type=checkbox name="howto_pay" value=""$c2{''}> <input type=checkbox name="howto_pay" value="i"$c2{'i'}>i <input type=checkbox name="howto_pay" value="NWbgJ[h"$c2{'NWbgJ[h'}>NWbgJ[h</blockquote>
<p>

<b></b><br>
oi͂ۂɔpłAoi҂]@ƂāAǂ炪S邩IłB
ꂩIȂƓo^ł܂̂ŁAȂꍇ(oiT[rXłĕ̂łȂƂAn]ꍇȂ)́AƂ肠ǂ炩IĂB
̓IȓeȂǂ́ADɓҊԂőkĂB<p>
<blockquote><input type=radio name="howto_carriage" value="D"$c3{'D'}>D҂𕉒S <input type=radio name="howto_carriage" value="oi"$c3{'oi'}>oi҂𕉒S</blockquote>
<p>

<b>i̎󂯓n</b><br>
i̎󂯓nɂāAK̎ɍsAi̎󂯓nɍsAoi҂]@ƂāAǂ炪S邩IłB
IĂꍇɂ́AxIĂB
̓Iȕ@Ȃǂ́ADɓҊԂőkĂB<p>
<blockquote><input type=radio name="howto_forward" value="x"$c4{'x'}>xɔ <input type=radio name="howto_forward" value="O"$c4{'O'}>O</blockquote>
<p>

<h3>y<u>oi(Ȃ)̏o^܂</u>z</h3>
DAD҂ɂ͂d[ē܂B
Dɂ͓ғmŘA荇A̓IȂbi߂ĂB
D҂̗vɂAd[ŘAȂꍇ́AI[NVǗ҂Aoi҂Ldbԍ܂͂e`wԍqAD҂ɂē邱ƂɂȂ܂B
<p>

<b>d[</b><br>
D҂ƘAdvȃAhXłB܂Aoio^ɂ͂ɋLꂽɁupX[hv𑗐M܂B
͂Ȃꍇ͋L~Xl邱ƂɂȂ܂B
ׂĔp(Ɂ}[NSpł͂Ȃ悤)Ad[AhX݂̂PLB<p>
<blockquote><input type=text name="email" value="$COOKIE{'email'}" size=40> <font size=-1>(pŐ)</font></blockquote>
<p>

<b>d[ȊO̘A</b><br>
d[L~XŘAȂꍇً̋}iƂāAdbԍƂe`wԍA܂͂̂ꂩLB
̏͗D҂̗v΁AI[NVǗ҂̔fŗD҂ɂēꍇ܂B<p>
<blockquote>
dbԍ <input type=text name="tel" value="$COOKIE{'tel'}" size=15>  03-1234-5678<br>
e`wԍ <input type=text name="fax" value="$COOKIE{'fax'}" size=15>
</blockquote>
<p>

<b>D҂ɎIɑ郁[̕ҏW</b><br>
DIėD҂ꍇɁAD҈ĂɎ̓e[M܂B
̎[ł͏oi҂̂d[AhX͗D҂ɂ͂m点܂̂ŁA
oi҂痎D҂֘AĂB
<p>
<blockquote>
<table border=1>
<tr bgcolor=#ffeedd>
<td>
<blockquote>
<br>
l<p>

oiԍ <br>
oii <p>

Ȃ͏L̏i𗎎D܂B<br>
x@⏤i̎@ɂẮAoi҂̘A҂B<p>

oi҂̃bZ[Wē܂B<br>
-----------------------------------------------------------------<br>
<textarea name="remarks" cols=60 rows=5 wrap=off>$in{'remarks'}</textarea><br>
-----------------------------------------------------------------<p>

ĨI[NVQƂɂ́Ãy[WɃANZXĂB<p>

$base_url<p>

<pre>$sign</pre>
</blockquote>
</td>
</tr>
</table>
</blockquote>
<p>

̏oio^́AuEUƂ$HTTP_USER_AGENTpA$HOSTs邱ƂOɋL^܂B<p>

<input type=submit name=";check;" value="  I emF  "> <input type=submit value="   pKɓӂďoi  "> <input type=reset value="  ~ Oɖ߂  " onClick="message(); return f">

</form>

<hr size=2 noshade>

<h3>spKt</h3>
<form><textarea cols=80 rows=10>
EOF

foreach (@KITEI) { print; }

print "\n"; #폜Ȃ.
print 'QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ' . "\n";
print "t[}[PbgVXe http://www.rescue.ne.jp/\n";
print "</textarea></form><p>\n";

print <<"EOF";
<h3><hr size=2 noshade>[<a href="auction.cgi">oiȂŖ߂</a>]<hr size=2 noshade></h3>
<table><tr><td>$reg_btm1</td></tr></table><p>
</body></html>
EOF

exit;

}

sub attachment {

print "Content-type: text/html\n\n";
print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
</HEAD>
$body
<form method=POST action="regist.cgi" ENCTYPE="multipart/form-data" name="form1">
<input type=hidden name="action" value="regist2">
<input type=hidden name="number" value="$in{'number'}">
<input type=hidden name="handle" value="$COOKIE{'handle'}">
<input type=hidden name="goods_name" value="$in{'goods_name'}">
<input type=hidden name="goods_remarks" value="$in{'goods_remarks'}">
<input type=hidden name="min_fee" value="$in{'min_fee'}">
<input type=hidden name="max_fee" value="$in{'max_fee'}">
<input type=hidden name="time" value="$in{'time'}">
<input type=hidden name="limit" value="$in{'limit'}">
EOF

foreach (split("\0",$in{'howto_pay'})) { print "<input type=hidden name=\"howto_pay\" value=\"$_\">\n"; }

print <<"EOF";
<input type=hidden name="howto_carriage" value="$in{'howto_carriage'}">
<input type=hidden name="howto_forward" value="$in{'howto_forward'}">
<input type=hidden name="email" value="$COOKIE{'email'}">
<input type=hidden name="tel" value="$COOKIE{'tel'}">
<input type=hidden name="fax" value="$COOKIE{'fax'}">
<input type=hidden name="remarks" value="$in{'remarks'}">
<h1>摜Yt</h1>
<table><tr>
EOF

foreach (split("\0",$in{'attc'})) {

	$i++;

	print "<td><table><tr><td align=center><img src=\"$tmp_url$_\" alt=\"\"><br><font size=-1><input type=checkbox name=\"remove\" value=\"$_\">Yt摜$i</font></td></tr></table><p>";
	print "<input type=hidden name=\"attc\" value=\"$_\"></td>\n";
}

foreach (@IMAGES) {

	$i++;

	print "<td><table><tr><td align=center><img src=\"$tmp_url$_\" alt=\"\"><br><font size=-1><input type=checkbox name=\"remove\" value=\"$_\">Yt摜$i</font></td></tr></table><p>";
	print "<input type=hidden name=\"attc\" value=\"$_\"></td>\n";
}

print <<"EOF";
</tr></table><p>
EOF

if ($i) {

	$add = "ǉ";
	print <<"EOF";
@<input type=submit name=";remove;" value="~폜"> <font size=-1>(폜摜`FbNĂ폜{^܂)</font><p>
EOF

}

if ($i < $attc_images) {

	print <<"EOF";
<pre>
@$addYt摜t@C <input type=file name="goods_view" size=50> <input type=submit value="  Yt ">

@ Q(Brows){^Ńt@CIAYt{^ĂB
@ t@Cɂ͔pJiы󔒂܂ł͂܂B
@ Ytł摜$attc_images܂łłB
EOF

}
else {
	print <<"EOF";
<hr size=1>
<pre>
@Ytł摜$attc_images܂łłB

EOF

}
print <<"EOF";

@<input type=submit name=";no_attc;" value="oio^ʂɖ߂">

@ uEU̖߂{^ł͖߂Ȃł.
</pre>
</form>
</body></html>
EOF

}

sub remove {

foreach (split("\0",$in{'remove'})) {

	if (-e "$tmp_dir$_") { unlink "$tmp_dir$_"; }
}

foreach $value (split("\0",$in{'attc'})) {

	if (-e "$tmp_dir$value") {

		$new .= "\0" if (defined($new));
		$new .= $value;
	}
}

$in{'attc'} = $new;

}

sub regist2 {

if ($in{'goods_view'} ne '') {

	$image_number = sprintf("%04d%02d%02d%02d%02d%02d",$year +1900,$mon +1,$mday,$hour,$min,$sec);

	foreach (@in) {

		($fname) = $_ =~ /\bfilename="([^"]*)"/i;
		($fname) = $_ =~ /\bfilename=([^\s:;]+)/i unless defined $fname;

		if ($fname eq '') { next; }

		($name) = $_ =~ /\bname="([^"]+)"/i;
		($name) = $_ =~ /\bname=([^\s:;]+)/i unless defined $name;

		($ctype) = $_ =~ /\s*Content-type:\s*"([^"]+)"/i;
		($ctype) = $_ =~ /\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;

		unless ($ctype =~ /^image/i) { push(@ERR,"oG[(010)FYtꂽt@C摜ǂmFł܂"); &html; }
		if ($ctype eq '') { push(@ERR,"oG[(011)FYtꂽt@C摜ǂmFł܂"); &html; }

		if ($name =~ /goods_view/) {

			$fname = reverse("$fname");
			($fname) = split(/\\|\/|\:/,$fname);
			$fname = reverse("$fname");
			($fname,$ext) = split(/\./,$fname);

			if (length($in{$name}) > $image_max) { 1 while $image_max =~ s/(.*\d)(\d\d\d)/$1,$2/g; push(@ERR,"TCYI[o[F摜$image_maxoCgȓɂĂ."); return; }

			if (!open(IMAGE,"> $tmp_dir$image_number\.$ext")) { push(@ERR,"VXeG[(012)FYtꂽt@CL^ł܂"); &html; }
			print IMAGE $in{$name};
			close(IMAGE);
			chmod(0666,"$tmp_dir$image_number\.$ext");
		}

		push(@IMAGES,"$image_number\.$ext");
		last;
	}
}

}

sub regist {

$date_now = sprintf("%01d/%01d(%s)%02d:%02d:%02d",$mon +1,$mday,$wday_array[$wday],$hour,$min,$sec);

if ($in{'handle'} eq '') { push(@ERR,"jbNl[FJ閼Oł"); }
elsif ($in{'handle'} =~ /[,:;<>=]/) { push(@ERR,"jbNl[F;:&lt;&gt;=,͎g܂"); }
if ($in{'goods_name'} eq '') { push(@ERR,"iFoi镨ȉڍׂĂ"); }
if (length($in{'goods_name'}) > 40) { push(@ERR,"iF40oCg(SpȂ20)ȓŏĂ"); }
if ($in{'goods_remarks'} eq '') { push(@ERR,"iFoi镨î̖ڂĂ"); }

$in{'min_fee'} =~ s/\,//g;
if ($in{'min_fee'} == 0 || $in{'min_fee'} =~ /\D/) { push(@ERR,"ŒᗎDiF̋zDJn܂Ep݂̂œ͂Ă"); }
elsif ($in{'min_fee'} < 100) { push(@ERR,"ŒᗎDiFŒݒz100~ł"); }

$plus_fee = &plus_fee($in{'min_fee'});
1 while $plus_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

$in{'max_fee'} =~ s/\,//g;
if ($in{'max_fee'} ne "" && ($in{'max_fee'} == 0 || $in{'max_fee'} =~ /\D/)) { push(@ERR,"]DiF̋ző܂Ep݂̂œ͂Ă"); }

if ($in{'max_fee'} != 0 && $in{'min_fee'} > $in{'max_fee'}) { push(@ERR,"]DiFŒᗎDiƓzzݒ肵Ă"); }

if ($in{'time'} eq '') { push(@ERR,"DԁFPPʂōőQTԂ܂ł͈̔͂łw肭"); }
if ($in{'howto_pay'} eq '') { push(@ERR,"x@Fw肭"); }
if ($in{'howto_carriage'} eq '') { push(@ERR,"Fw肭"); }
if ($in{'howto_forward'} eq '') { push(@ERR,"Fw肭"); }
if ($in{'email'} !~ /\b[-\w.]+@[-\w.]+\.[-\w]+\b/) { push(@ERR,"d[FpŐLqĂ"); }
if ($in{'email'} =~ /[,:;<>=]/) { push(@ERR,"d[F;:&lt;&gt;=,͎g܂"); }
if ($in{'tel'} eq '' && $in{'fax'} eq '') { push(@ERR,"dbԍ܂͂e`wԍFd[ȊO̘AiƂďȂƂꂩ͂L"); }
if ($in{'tel'} =~ /[,:;<>=]/) { push(@ERR,"dbԍF;:&lt;&gt;=,͎g܂"); }
if ($in{'fax'} =~ /[,:;<>=]/) { push(@ERR,"FAXԍF;:&lt;&gt;=,͎g܂"); }

umask(000);

$in{'passwd'} = "";
@char = ('a'..'k','m','n','p'..'z','A'..'H','J'..'N','P'..'Z','2'..'9');

srand(time|$$);
foreach (0..7) {
	{
		local(@temp);
		push(@temp,splice(@char,rand(@char),1)) while @char;
		@char = @temp;
	}
	$in{'passwd'} = $char[($_)] . $in{'passwd'};
}

if (-e "$tmp_dir$in{'limit'}") { push(@ERR,"G[(013)Fdɏoi{^܂. ɓo^ĂƎv܂. <a href=\"auction.cgi\">o^mF</a>Ă."); $no_remove = 1; &html; }

if (!open(CHECK,"> $tmp_dir$in{'limit'}")) { push(@ERR,"VXeG[(012)FƗpf[^L^ł܂"); &html; }
close(CHECK);

if (!mkdir("$base_dir$in{'number'}",0777)) { push(@ERR,"VXeG[(014)Ff[^L^ł܂ł($!)"); unlink "$tmp_dir$in{'limit'}"; &html; }

$limit = time + ($in{'time'} * 86400);

if (!open(DATA,"> $base_dir$in{'number'}\/index.$data_ext")) { push(@ERR,"VXeG[(015)Ftł܂ł"); unlink "$tmp_dir$in{'limit'}"; &html; }
print DATA "start\t$date_now\n";
print DATA "host\t$HOST\n";
while (($key,$val) = each %in) {

	if ($key eq 'action') { next; }
	if ($key eq 'goods_view') { next; }
	if ($key eq 'number') { next; }
	if ($key eq 'limit') { next; }
	foreach (split("\0",$val)) { print DATA "$key\t$_\n"; }
}
close(DATA);

chmod(0666,"$base_dir$in{'number'}\/index.$data_ext");

if (@ERR) { unlink "$tmp_dir$in{'limit'}"; &html; }

if (!rename("$base_dir$in{'number'}","$base_dir$limit\.1")) { push(@ERR,"VXeG[(016)Ftł܂ł($!)"); unlink "$tmp_dir$in{'limit'}"; &html; }

if (@ERR) { unlink "$tmp_dir$in{'limit'}"; &html; }

foreach $img_file (split("\0",$in{'attc'})) {

	if (open(IMG,"$tmp_dir$img_file")) {

		@data = <IMG>;
		close(IMG);

		unlink("$tmp_dir$img_file");

		if (open(IMG,"> $base_dir$limit\.1\/$img_file")) {

			print IMG @data;
			close(IMG);
		}
	}
}

$log = "$log_dir" . "regist.$data_ext";

if (!open(DATA,">> $log")) { &error("VXeG[(017)","oio^pOɋL^ł܂"); }
print DATA "NEW -- $date_now\n";
print DATA "ڑzXg $HOST\n";
print DATA "uEU $HTTP_USER_AGENT\n";
print DATA "oiԍ(⍇ԍ) $limit\n";
print DATA "oii $in{'goods_name'}\n";
print DATA "ŒᗎDi $in{'min_fee'}\n";
print DATA "DP $plus_fee\n";
print DATA "]Di $in{'max_fee'}\n";
print DATA "D $in{'time'}\n";
print DATA "x@ ";
foreach (split("\0",$in{'howto_pay'})) { print DATA " $_"; }
print DATA "\nS $in{'howto_carriage'}\n";
print DATA " $in{'howto_forward'}\n";
print DATA "jbNl[ $in{'handle'}\n";
print DATA "d[ $in{'email'}\n";
print DATA "db $in{'tel'}\n";
print DATA "e`w $in{'fax'}\n";
print DATA "pX[h $in{'passwd'}\n";
print DATA "\n";
close(DATA);
chmod(0666,"$base_dir$log");

if ($hiho) {

	$SUBJECT = "\[$limit\] Auction";
	if (!open(OUT,"| $sendmail -s \"$SUBJECT\" -f \"$mailto\" $in{'email'}")) { &error("VXeG[","[ł܂ł"); }
}
else {
	if (!open(OUT,"| $sendmail -t")) { &error("VXeG[","[ł܂ł"); }

	print OUT &jis("X-Processed: $date_now\n");
	print OUT "X-Mailer: PERSONAL AUCTION SYSTEM by www.rescue.ne.jp\n";
	print OUT "X-HTTP-REFERER: $ENV{'HTTP_REFERER'}\n";
	print OUT "To: $in{'email'}\n";
	print OUT "From: $mailto\n";
	print OUT &jis("Subject: \[$limit\] oio^̂m点\n");
	print OUT "\n";
}

print OUT "\n";
print OUT &jis("$date_now$HOST\n");
print OUT &jis("oio^a肵܂B\n");
print OUT &jis($head);
print OUT "\n";

print OUT &jis("oiԍ $limit\n");
print OUT &jis("oii $in{'goods_name'}\n");

print OUT &jis("ŒᗎDi $min_fee ~\n");
print OUT &jis("DP $plus_fee ~\n");
if ($in{'max_fee'} != 0) { print OUT &jis("]Di $max_fee\n"); }

print OUT &jis("D $in{'time'}\n");
print OUT &jis("x@ ");
foreach (split("\0",$in{'howto_pay'})) { print OUT &jis(" $_"); }
print OUT "\n";
print OUT &jis("S $in{'howto_carriage'}\n");
print OUT &jis(" $in{'howto_forward'}\n");
print OUT "\n";
print OUT &jis("jbNl[ $in{'handle'}\n");
print OUT &jis("d[ $in{'email'}\n");
if ($in{'tel'} ne '') { print OUT &jis("db $in{'tel'}\n"); }
if ($in{'fax'} ne '') { print OUT &jis("e`w $in{'fax'}\n"); }

print OUT "\n";
print OUT &jis("Drł̏oiADI̗D҉{ďoiȂǂ́A\n");
print OUT &jis("oi҂ƂďoiʂɃANZXKv܂Boiʂ̉\n");
print OUT &jis("DǗtH[܂̂ŁAɉL̃pX[h͂āA\n");
print OUT &jis("ẽ{^ĂB\n\n");

print OUT &jis("pX[h $in{'passwd'}\n\n");

print OUT &jis("oiʂւ̃ANZXURL͎̃y[Włē܂B\n");
print OUT &jis("DƓDIł̓ANZX悪قȂ܂̂łӂB\n\n");

print OUT &jis("$base_url" . "redirect.cgi\n");

print OUT "\n";
print OUT &jis($sign);
close(OUT);

$in{'goods_remarks'} =~ s/\r/<br>\r/g;

($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg) = gmtime(time + 30*24*60*60);
$y0="Sunday"; $y1="Monday"; $y2="Tuesday"; $y3="Wednesday"; $y4="Thursday"; $y5="Friday"; $y6="Saturday";
$m0="Jan"; $m1="Feb"; $m2="Mar"; $m3="Apr"; $m4="May"; $m5="Jun"; $m6="Jul"; $m7="Aug"; $m8="Sep"; $m9="Oct"; $m10="Nov"; $m11="Dec";
@youbi = ($y0,$y1,$y2,$y3,$y4,$y5,$y6);
@monthg = ($m0,$m1,$m2,$m3,$m4,$m5,$m6,$m7,$m8,$m9,$m10,$m11);
$date_gmt = sprintf("%s\, %02d\-%s\-%04d %02d:%02d:%02d GMT",$youbi[$wdayg],$mdayg,$monthg[$mong],$yearg +1900,$hourg,$ming,$secg);

print "Set-Cookie: $ENV{'SCRIPT_NAME'}=handle:$COOKIE{'handle'}\,email:$COOKIE{'email'}\,tel:$COOKIE{'tel'}\,fax:$COOKIE{'fax'}; expires=$date_gmt\n";
print "Content-type: text/html\n\n";
print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
</HEAD>
$body
<h1>oi</h1>
$registed<p>

<table width=100%>
<tr>
<td bgcolor=#ffe566 colspan=2><font size=+2><b>$in{'goods_name'}</b></font></td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>oiԍ</b></font></td>
<td bgcolor=#ffffff>$limit</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>oi</b></font></td>
<td bgcolor=#ffffff>$in{'handle'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>ŒᗎDi</b></font></td>
<td bgcolor=#ffffff>$min_fee~</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>DP</b></font></td>
<td bgcolor=#ffffff>$plus_fee ~</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>]Di</b></font></td>
<td bgcolor=#ffffff>$max_fee</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>D</b></font></td>
<td bgcolor=#ffffff>$in{'time'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>x@</b></font></td>
<td bgcolor=#ffffff>
EOF

foreach (split("\0",$in{'howto_pay'})) { print "$_ "; }

print <<"EOF";
</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>S</b></font></td>
<td bgcolor=#ffffff>$in{'howto_carriage'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b></b></font></td>
<td bgcolor=#ffffff>$in{'howto_forward'}</td>
</tr>
</table>
<p>
EOF

print "<table><tr>";
foreach (split("\0",$in{'attc'})) { print "<td><img src=\"image.cgi?dir=$limit\%2e1&iname=$_\" alt=\"Yt摜$i\"></td>\n"; }
foreach $image_number (@IMAGES) { print "<td><img src=\"image.cgi?dir=$limit\%2e1&iname=$image_number\" alt=\"Yt摜$i\"></td>\n"; }
print "</tr></table>\n";
if ($in{'attc'} || @IMAGES) { print "<p>\n"; }

print "$VALUE<p>\n";

$URL = "$base_url" . "tender.cgi?number=$limit" . "1";

print <<"EOF";
̏oiʂւ̃ANZX <a href="$URL">$URL</a> łB

<h3><hr size=2 noshade>[<a href="auction.cgi">oiꗗ</a>]<hr size=2 noshade></h3>
</body></html>
EOF

}
